package com.fireworksdk.bridge.models

import org.json.JSONObject

object FWButtonInfoDeserializer {

  private const val IMAGE_NAME_KEY = "imageName"
  private const val TINT_COLOR_KEY = "tintColor"

  fun deserialize(responseJson: JSONObject?): FWButtonInfoModel? {
    responseJson ?: return null

    val imageName = if (responseJson.has(IMAGE_NAME_KEY)) responseJson.optString(IMAGE_NAME_KEY) else null
    val tintColor = if (responseJson.has(TINT_COLOR_KEY)) responseJson.optString(TINT_COLOR_KEY) else null

    return FWButtonInfoModel(
      imageName = imageName,
      tintColor = tintColor
    )
  }
}