package com.fireworksdk.bridge.models

import com.fireworksdk.bridge.models.enums.FWSystemTypeface
import org.json.JSONObject

object FWFontInfoModelDeserializer {

  private const val IS_CUSTOM_KEY = "isCustom"
  private const val TYPEFACE_NAME_KEY = "typefaceName"

  fun deserialize(responseJson: JSONObject?): FWFontInfoModel? {
    responseJson ?: return null

    val isCustom = responseJson.optBoolean(IS_CUSTOM_KEY, false)
    val typefaceName = if (responseJson.has(TYPEFACE_NAME_KEY)) responseJson.optString(TYPEFACE_NAME_KEY) else null

    return FWFontInfoModel(
      isCustom = isCustom,
      typefaceName = if (!typefaceName.isNullOrBlank()) FWSystemTypeface.deserialize(typefaceName) else null,
    )
  }
}
