package com.fireworksdk.bridge.models

import com.fireworksdk.bridge.models.enums.FWSystemTypeface
import org.json.JSONObject

object FWFontInfoModelSerializer {

  private const val IS_CUSTOM_KEY = "isCustom"
  private const val TYPEFACE_NAME_KEY = "typefaceName"

  fun serialize(model: FWFontInfoModel?): JSONObject? {
    model ?: return null
    val jsonObject = JSONObject()
    jsonObject.put(IS_CUSTOM_KEY, model.isCustom)
    jsonObject.put(TYPEFACE_NAME_KEY, FWSystemTypeface.serialize(model.typefaceName))
    return jsonObject
  }
}