package com.fireworksdk.bridge.models

import com.fireworksdk.bridge.models.enums.FWCtaButtonTextValue
import com.fireworksdk.bridge.models.enums.FWProductCardCtaButtonTextValue
import com.fireworksdk.bridge.models.enums.FWProductCardTheme

data class FWProductInfoViewConfiguration(
  val ctaButton: CtaButtonConfiguration? = null,
  val linkButton: LinkButtonConfiguration? = null,
  val productCard: ProductCardConfiguration? = null,
) {

  data class CtaButtonConfiguration(
    val text: FWCtaButtonTextValue? = null,
    val backgroundColor: String? = null,
    val textColor: String? = null,
    val fontSize: Int? = null,
  )

  data class LinkButtonConfiguration(
    val isHidden: Boolean? = null,
  )

  data class ProductCardConfiguration(
    val ctaButtonText: FWProductCardCtaButtonTextValue? = null,
    val theme: FWProductCardTheme? = null,
    val cornerRadius: Int? = null,
    val priceConfiguration: ProductCardPriceConfiguration? = null,
    val isCtaButtonHidden: Boolean? = null,
  )

  data class ProductCardPriceConfiguration(
    val isHidden: Boolean? = null,
  )
}
