package com.fireworksdk.bridge.models

import com.fireworksdk.bridge.models.enums.FWShoppingCtaResultRes
import org.json.JSONObject

object FWShoppingCtaResultDeserializer {

  private const val RES_KEY = "res"
  private const val TIPS_KEY = "tips"

  fun deserialize(responseJson: JSONObject?): FWShoppingCtaResult? {
    responseJson?: return null

    val resString = if (responseJson.has(RES_KEY)) responseJson.optString(RES_KEY) else null
    val tips = if (responseJson.has(TIPS_KEY)) responseJson.optString(TIPS_KEY) else null

    return FWShoppingCtaResult(
      res = if (!resString.isNullOrBlank()) FWShoppingCtaResultRes.deserialize(resString) else null,
      tips = tips,
    )
  }
}
