package com.fireworksdk.bridge.models.enums

enum class FWErrorAction(val rawValue: String) {
  LoadingFirstPage("loadingFirstPage"),
  LoadingNextPage("loadingNextPage");

  companion object {
    fun deserialize(rawValue: String?): FWErrorAction? {
      rawValue ?: return null
      return FWErrorAction.values().first { it.rawValue == rawValue }
    }

    fun serialize(model: FWErrorAction?): String? {
      model ?: return null
      return model.rawValue
    }
  }
}