//
//  VideoFeedConfiguration.swift
//  fw_flutter_sdk
//
//  Created by Jeff Zheng on 2021/12/28.
//

import Foundation

@objc
public class VideoFeedConfiguration: NSObject, Codable {
    var backgroundColor: String?
    var cornerRadius: Double?
    var title: VideoFeedTitleConfiguration?
    var titlePosition: VideoFeedTitlePosition?
    var titlePadding: VideoFeedPadding?
    var playIcon: VideoFeedPlayIconConfiguration?
    var showAdBadge: Bool?
    var aspectRatio: Double?
    var contentPadding: VideoFeedPadding?
    var itemSpacing: Double?
    var enableAutoplay: Bool?
    var gridColumns: Int?

    class VideoFeedTitleConfiguration: NSObject, Codable {
        public var hidden: Bool?
        public var textColor: String?
        public var fontSize: Double?
        public var numberOfLines: Int?
        public var iOSFontInfo: FontInfo?
    }

    class VideoFeedPlayIconConfiguration: NSObject, Codable {
        public var hidden: Bool?
        public var iconWidth: Double?
    }

    class VideoFeedPadding: NSObject, Codable {
        public var top: Double?
        public var right: Double?
        public var bottom: Double?
        public var left: Double?
    }

    enum VideoFeedTitlePosition: String, Codable {
        case stacked, nested
    }
}
