//
//  FireworkSdk+CTA.swift
//  fw_flutter_sdk
//
//  Created by Jeff Zheng on 2021/12/21.
//

import FireworkVideo
import Foundation

extension FireworkSDKPlugin: FireworkVideoCTADelegate {
    func handleCustomCTAClick(_ viewController: PlayerViewController, url: URL) -> Bool {
        let callbackId = UUID().uuidString
        playerMap.setObject(viewController, forKey: callbackId as NSString)
        channel?.invokeMethod(
            FWEventName.customCTAClick.rawValue,
            arguments: [
                "url": url.absoluteString,
                "callbackId": callbackId]
        )

        return customCTAClickEnabled
    }

    func pausePlayer(_ callbackId: String) {
        if let playerViewController = playerMap.object(forKey: callbackId as NSString),
           let playerViewController = playerViewController as? PlayerViewController {
            playerViewController.pause()
        }
    }

    func resumePlayer(_ callbackId: String) {
        if let playerViewController = playerMap.object(forKey: callbackId as NSString),
           let playerViewController = playerViewController as? PlayerViewController {
            playerViewController.resume()
        }
    }
}
