//
//  SDKInitOptions.swift
//
//  Created by linjie jiang on 2023/3/8.
//

import Foundation
import FireworkVideo

public struct SDKInitOptions: Codable {
    public var userId: String?
    public var videoLaunchBehavior: FWFVideoLaunchBehavior?
    public init(userId: String? = nil, videoLaunchBehavior: FWFVideoLaunchBehavior? = nil) {
        self.userId = userId
        self.videoLaunchBehavior = videoLaunchBehavior
    }
}

public enum FWFVideoLaunchBehavior: String, Codable {
    case `default`, muteOnFirstLaunch
}

extension FWFVideoLaunchBehavior {
    func behavior() -> VideoPlayerContentConfiguration.VideoLaunchBehavior {
        switch self {
        case .muteOnFirstLaunch:
            return .muteOnFirstLaunch
        default:
            return .`default`
        }
    }
}
