//
//  SwiftFireworkFlutterSdkPlugin.swift
//  fw_flutter_sdk
//
//  Created by Jeff Zheng on 2022/2/21.
//

import Flutter
import Foundation

@objc(SwiftFireworkFlutterSdkPlugin)
public class SwiftFireworkFlutterSdkPlugin: NSObject, FlutterPlugin {

    public static func register(with registrar: FlutterPluginRegistrar) {
        FireworkSDKPlugin.register(with: registrar)
        ShoppingPlugin.register(with: registrar)
        LiveStreamPlugin.register(with: registrar)
        NavigatorPlugin.register(with: registrar)

        let videoFeedViewFactory = VideoFeedViewFactory(messenger: registrar.messenger())
        registrar.register(videoFeedViewFactory, withId: ViewTypeId.videoFeed.rawValue)

        let storyBlockViewFactory = StoryBlockViewFactory(messenger: registrar.messenger())
        registrar.register(storyBlockViewFactory, withId: ViewTypeId.storyBlock.rawValue)
    }
}
