//
//  UIViewController+FWSwizzle.swift
//
//  Created by linjie jiang on 8/8/23.
//

import Foundation
import FireworkVideo

extension UIViewController {
    static func swizzleLifecycleMethods() {
        Swizzle.swizzleSelector(
            cls: self,
            originalSelector: #selector(UIViewController.addChild(_:)),
            customSelector: #selector(UIViewController.ffs_addChild(_:))
        )

        Swizzle.swizzleSelector(
            cls: self,
            originalSelector: #selector(UIViewController.removeFromParent),
            customSelector: #selector(UIViewController.ffs_removeFromParent)
        )
    }

    @objc func ffs_addChild(_ childController: UIViewController) {
        ffs_addChild(childController)
        if self is StoryBlockViewController,
           !(childController is PlayerViewRepresentable),
           let storyBlock = self.view.superview as? StoryBlock {
            storyBlock.notifyPdpVisibilityChange(true)
        }
    }

    @objc func ffs_removeFromParent() {
        if let parentVC = self.parent as? StoryBlockViewController,
           !(self is PlayerViewRepresentable),
           let storyBlock = parentVC.view.superview as? StoryBlock {
            storyBlock.notifyPdpVisibilityChange(false)
        }
        ffs_removeFromParent()
    }
}
