import 'fw_error.dart';

enum FWNativeErrorAction {
  loadingFirstPage,
  loadingNextPage,
}

class FWNativeError extends FWError {
  final String? action;

  FWNativeError({
    required super.name,
    super.reason,
    this.action,
  });

  FWError toError() {
    return FWError(
      name: name,
      reason: reason,
    );
  }

  static FWNativeError? createNativeErrorWithError(FWError? error) {
    if (error == null) {
      return null;
    }

    return FWNativeError(
      name: error.name,
      reason: error.reason,
    );
  }
}
