enum VideoPlayerCTADelayType {
  constant,
  percentage,
}

class VideoPlayerCTADelay {
  VideoPlayerCTADelayType type;
  double value;

  VideoPlayerCTADelay({
    required this.type,
    required this.value,
  });

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is VideoPlayerCTADelay) {
      return type == other.type && value == other.value;
    }

    return false;
  }

  @override
  int get hashCode => type.hashCode ^ value.hashCode;

  VideoPlayerCTADelay deepCopy() => VideoPlayerCTADelay(
        type: type,
        value: value,
      );
}
