enum VideoPlayerLogoOption {
  disabled,
  creator,
  channelAggregator,
}

class VideoPlayerLogoConfiguration {
  /// Specifies the logo type.
  /// Defaults to 'disabled'.
  /// Only supported on iOS.
  VideoPlayerLogoOption option;

  /// Specifies the logo encoding id.
  /// Required when option is 'creator' or 'channelAggregator'.
  /// Only supported on iOS.
  String? encodedId;
  VideoPlayerLogoConfiguration({
    required this.option,
    this.encodedId,
  });

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is VideoPlayerLogoConfiguration) {
      return option == other.option && encodedId == other.encodedId;
    }

    return false;
  }

  @override
  int get hashCode => option.hashCode ^ encodedId.hashCode;

  VideoPlayerLogoConfiguration deepCopy() => VideoPlayerLogoConfiguration(
        option: option,
        encodedId: encodedId,
      );
}
