import './video_player_configuration.dart';

class VideoPlayerNativeConfiguration extends VideoPlayerConfiguration {
  /// Specifies if Picture in Picture is enabled.
  bool? enablePictureInPicture;

  VideoPlayerNativeConfiguration({
    super.playerStyle,
    super.videoCompleteAction,
    super.showShareButton,
    super.ctaButtonStyle,
    super.showPlaybackButton,
    super.showMuteButton,
    super.showBranding,
    super.ctaDelay,
    super.ctaHighlightDelay,
    super.shareBaseURL,
    super.ctaWidth,
    super.buttonConfiguration,
    super.videoPlayerLogoConfiguration,
    super.showVideoDetailTitle,
    this.enablePictureInPicture,
  });

  VideoPlayerNativeConfiguration.withPlayerConfiguration({
    VideoPlayerConfiguration? playerConfiguration,
    bool? enablePictureInPicture,
  }) : this(
          playerStyle: playerConfiguration?.playerStyle,
          videoCompleteAction: playerConfiguration?.videoCompleteAction,
          showShareButton: playerConfiguration?.showShareButton,
          ctaButtonStyle: playerConfiguration?.ctaButtonStyle,
          showPlaybackButton: playerConfiguration?.showPlaybackButton,
          showMuteButton: playerConfiguration?.showMuteButton,
          showBranding: playerConfiguration?.showBranding,
          ctaDelay: playerConfiguration?.ctaDelay,
          ctaHighlightDelay: playerConfiguration?.ctaHighlightDelay,
          shareBaseURL: playerConfiguration?.shareBaseURL,
          ctaWidth: playerConfiguration?.ctaWidth,
          buttonConfiguration: playerConfiguration?.buttonConfiguration,
          videoPlayerLogoConfiguration:
              playerConfiguration?.videoPlayerLogoConfiguration,
          showVideoDetailTitle: playerConfiguration?.showVideoDetailTitle,
          enablePictureInPicture: enablePictureInPicture,
        );

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is VideoPlayerNativeConfiguration) {
      return super == other &&
          enablePictureInPicture == other.enablePictureInPicture;
    }

    return false;
  }

  @override
  int get hashCode => super.hashCode ^ enablePictureInPicture.hashCode;

  @override
  VideoPlayerNativeConfiguration deepCopy() =>
      VideoPlayerNativeConfiguration.withPlayerConfiguration(
        playerConfiguration: super.deepCopy(),
        enablePictureInPicture: enablePictureInPicture,
      );
}
