import 'dart:async';

class FWGlobalState {
  static FWGlobalState? _instance;

  static FWGlobalState _getInstance() {
    _instance ??= FWGlobalState._();
    return _instance!;
  }

  FWGlobalState._();

  factory FWGlobalState.getInstance() => _getInstance();

  final Completer<void> _sdkInitCalledCompleter = Completer();

  Future<void> get sdkInitCalledFuture => _sdkInitCalledCompleter.future;

  bool _sdkInitCalled = false;
  bool get sdkInitCalled => _sdkInitCalled;

  void completeSdkInitCalledFuture() {
    if (_sdkInitCalledCompleter.isCompleted) {
      return;
    }

    _sdkInitCalledCompleter.complete();
    _sdkInitCalled = true;
  }
}
