import '../../models/ad_badge_configuration.dart';
import 'android_font_info_util.dart';

class AdBadgeConfigurationUtil {
  static Map<String, dynamic> toJson(AdBadgeConfiguration config) {
    Map<String, dynamic> json = {};
    String rawBadgeTextType = config.badgeTextType?.name ?? "";
    if (rawBadgeTextType.isNotEmpty) {
      json["badgeTextType"] = rawBadgeTextType;
    }

    if (config.backgroundColor != null && config.backgroundColor!.isNotEmpty) {
      json["backgroundColor"] = config.backgroundColor!;
    }

    if (config.textColor != null && config.textColor!.isNotEmpty) {
      json["textColor"] = config.textColor!;
    }

    if (config.androidFontInfo != null) {
      json["androidFontInfo"] =
          AndroidFontInfoUtil.toJson(config.androidFontInfo!);
    }
    return json;
  }
}
