import 'ios_font_info_util.dart';
import '../../models/product_info_view_configuration.dart';

class ProductInfoViewConfigurationUtil {
  static Map<String, dynamic> _convertToCTAButtonToJson(
      ShoppingCTAButtonConfiguration config) {
    Map<String, dynamic> json = {};
    if (config.text != null) {
      json["text"] = config.text!.name;
    }

    if (config.backgroundColor != null) {
      json["backgroundColor"] = config.backgroundColor;
    }

    if (config.textColor != null) {
      json["textColor"] = config.textColor;
    }

    if (config.fontSize != null) {
      json["fontSize"] = config.fontSize!.toDouble();
    }

    if (config.iOSFontInfo != null) {
      json["iOSFontInfo"] = IOSFontInfoUtil.toJson(config.iOSFontInfo!);
    }

    return json;
  }

  static Map<String, dynamic> _convertToLinkButtonToJson(
      LinkButtonConfiguration config) {
    Map<String, dynamic> json = {};
    if (config.isHidden != null) {
      json["isHidden"] = config.isHidden!;
    }

    return json;
  }

  static Map<String, dynamic> _convertToProductCardCTAButtonStyleToJson(
      ProductCardCTAButtonStyle config) {
    Map<String, dynamic> json = {};
    if (config.textColor != null) {
      json["textColor"] = config.textColor!;
    }

    if (config.fontSize != null) {
      json["fontSize"] = config.fontSize!;
    }

    if (config.iOSFontInfo != null) {
      json["iOSFontInfo"] = IOSFontInfoUtil.toJson(config.iOSFontInfo!);
    }
    return json;
  }

  static Map<String, dynamic> _convertToProductCardLabelConfigurationToJson(
      ProductCardLabelConfiguration config) {
    Map<String, dynamic> json = {};
    if (config.textColor != null) {
      json["textColor"] = config.textColor!;
    }

    if (config.fontSize != null) {
      json["fontSize"] = config.fontSize!;
    }

    if (config.numberOfLines != null) {
      json["numberOfLines"] = config.numberOfLines!;
    }

    if (config.iOSFontInfo != null) {
      json["iOSFontInfo"] = IOSFontInfoUtil.toJson(config.iOSFontInfo!);
    }
    return json;
  }

  static Map<String, dynamic> _convertToProductCardPriceConfigurationToJson(
      ProductCardPriceConfiguration config) {
    Map<String, dynamic> json = {};
    // ignore: deprecated_member_use_from_same_package
    if (config.isHidden != null) {
      // ignore: deprecated_member_use_from_same_package
      json["isHidden"] = config.isHidden!;
    }

    if (config.axis != null) {
      json["axis"] = config.axis!.name;
    }

    if (config.priceLabel != null) {
      json["priceLabel"] =
          _convertToProductCardLabelConfigurationToJson(config.priceLabel!);
    }

    if (config.originalPriceLabel != null) {
      json["originalPriceLabel"] =
          _convertToProductCardLabelConfigurationToJson(
              config.originalPriceLabel!);
    }

    if (config.isPriceFirst != null) {
      json["isPriceFirst"] = config.isPriceFirst!;
    }

    return json;
  }

  static Map<String, dynamic> _convertToProductCardIconConfigurationToJson(
      ProductCardIconConfiguration config) {
    Map<String, dynamic> json = {};
    if (config.cornerRadius != null) {
      json["cornerRadius"] = config.cornerRadius!;
    }

    return json;
  }

  static Map<String, dynamic> _convertToProductCardToJson(
      ProductCardConfiguration config) {
    Map<String, dynamic> json = {};
    if (config.theme != null) {
      json["theme"] = config.theme!.name;
    }

    if (config.cornerRadius != null) {
      json["cornerRadius"] = config.cornerRadius!;
    }

    if (config.isCtaButtonHidden != null) {
      json["isCtaButtonHidden"] = config.isCtaButtonHidden!;
    }

    if (config.ctaButtonText != null) {
      json["ctaButtonText"] = config.ctaButtonText!.name;
    }

    if (config.ctaButtonStyle != null) {
      json["ctaButtonStyle"] =
          _convertToProductCardCTAButtonStyleToJson(config.ctaButtonStyle!);
    }

    if (config.priceConfiguration != null) {
      json["priceConfiguration"] =
          _convertToProductCardPriceConfigurationToJson(
              config.priceConfiguration!);
    }

    if (config.width != null) {
      json["width"] = config.width!;
    }

    if (config.height != null) {
      json["height"] = config.height!;
    }

    if (config.backgroundColor != null) {
      json["backgroundColor"] = config.backgroundColor!;
    }

    if (config.iconConfiguration != null) {
      json["iconConfiguration"] = _convertToProductCardIconConfigurationToJson(
          config.iconConfiguration!);
    }

    if (config.nameLabel != null) {
      json["nameLabel"] =
          _convertToProductCardLabelConfigurationToJson(config.nameLabel!);
    }

    return json;
  }

  static Map<String, dynamic> toJson(ProductInfoViewConfiguration config) {
    Map<String, dynamic> json = {};

    if (config.ctaButton != null) {
      json["ctaButton"] = _convertToCTAButtonToJson(config.ctaButton!);
    }

    if (config.linkButton != null) {
      json["linkButton"] = _convertToLinkButtonToJson(config.linkButton!);
    }

    if (config.productCard != null) {
      json["productCard"] = _convertToProductCardToJson(config.productCard!);
    }

    return json;
  }
}
