import 'package:flutter_test/flutter_test.dart';
import 'package:fw_flutter_sdk/src/models/video_playback_details.dart';
import 'package:fw_flutter_sdk/src/utils/model_utils/video_playback_details_util.dart';

void main() {
  test('VideoPlaybackDetailsUtil createVideoPlaybackEventName', () {
    for (var value in VideoPlaybackEventName.values) {
      expect(
          VideoPlaybackDetailsUtil.createVideoPlaybackEventName(value.rawName),
          value);
    }
  });

  test('VideoPlaybackDetailsUtil fromJson', () {
    final playerSizeJson = {
      "width": 100,
      "height": 150,
    };
    final json = {
      "videoId": "test_video_id",
      "duration": 100,
      "caption": "test_caption",
      "badge": "test_badge",
      "playerSize": playerSizeJson,
      "hasCTA": true,
    };
    final detail = VideoPlaybackDetailsUtil.fromJson(json);

    expect(detail?.videoId, json["videoId"]);
    expect(detail?.duration, json["duration"]);
    expect(detail?.caption, json["caption"]);
    expect(detail?.badge, json["badge"]);
    expect(detail?.playerSize?.width, playerSizeJson["width"]);
    expect(detail?.playerSize?.height, playerSizeJson["height"]);
    expect(detail?.hasCTA, json["hasCTA"]);
  });
}
